package org.activiti.crystalball.simulator.impl.clock;

/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import org.activiti.engine.impl.util.DefaultClockImpl;
import org.activiti.engine.runtime.Clock;
import org.springframework.beans.factory.FactoryBean;

/**
 * This class provides factory for default clocks
 * 
 * @author martin.grofcik
 */
public class DefaultClockFactory implements FactoryBean<Clock> {
  @Override
  public Clock getObject() throws RuntimeException {
    return new DefaultClockImpl();
  }

  @Override
  public Class<?> getObjectType() {
    return DefaultClockImpl.class;
  }

  @Override
  public boolean isSingleton() {
    return false;
  }
}
