/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.activiti.engine.impl.bpmn.behavior;

import org.activiti.engine.delegate.DelegateExecution;

/**
 * @author Daniel Meyer
 * @author Joram Barrez
 */
public class EventBasedGatewayActivityBehavior extends FlowNodeActivityBehavior {
  
  private static final long serialVersionUID = 1L;

  @Override
  public void execute(DelegateExecution execution) {
    
    // The event based gateway simply leaves directly, in the default BPMN 2.0 way 
    // (taking all sequence flow in parallel)
    leave(execution);
    
  }

}
