/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.activiti.engine.impl.persistence.entity;

import java.util.Collection;
import java.util.List;

import org.activiti.engine.impl.variable.VariableType;

/**
 * @author Joram Barrez
 */
public interface VariableInstanceEntityManager extends EntityManager<VariableInstanceEntity> {

  VariableInstanceEntity create(String name, VariableType type, Object value);

  VariableInstanceEntity createAndInsert(String name, VariableType type, Object value);

  List<VariableInstanceEntity> findVariableInstancesByTaskId(String taskId);

  Collection<VariableInstanceEntity> findVariableInstancesByExecutionId(String executionId);

  VariableInstanceEntity findVariableInstanceByExecutionAndName(String executionId, String variableName);

  List<VariableInstanceEntity> findVariableInstancesByExecutionAndNames(String executionId, Collection<String> names);

  VariableInstanceEntity findVariableInstanceByTaskAndName(String taskId, String variableName);

  List<VariableInstanceEntity> findVariableInstancesByTaskAndNames(String taskId, Collection<String> names);

  void deleteVariableInstanceByTask(TaskEntity task);

}